import React, { createElement, PropTypes } from 'react';
import classnames from 'classnames';
import namespace from '../../namespace';

const classNamespace = namespace('app__components-editor', true);
const noop = function () {};

export default class Exception extends React.Component {
  static propTypes = {
    onClose: PropTypes.func
  };

  static defaultProps = {
    onClose: noop
  };

  onIconClose = (e) => {
    const { onClose } = this.props;

    onClose(e);
  }

  render () {
    const { message = 'Unknown Exception', visiable } = this.props;

    const iconClass = classnames({
      ['iconfont']: true,
      ['icon-close']: true,
      [classNamespace('exception-icon')]: true
    });

    const classes = classnames({
      [classNamespace('exception', 'visiable')]: visiable,
      [classNamespace('exception')]: true
    });

    return (
      <div className={classes}>
        {message}
        <i className={iconClass} onClick={this.onIconClose}></i>
      </div>
    );
  }
}