import React, { cloneElement, PropTypes, createElement, Children } from 'react';
import classnames from 'classnames';

import namespace from '../../namespace';

import Item from './item';

const classNamespace = namespace('app__components', true);
const noop = function () {};

export default class View extends React.Component {
  static Item = Item;

  visiableView () {
    const { selectedKey, children } = this.props;
    
    return Children.map(children, c => cloneElement(c, { visiable: selectedKey === c.key }));
  }

  render () {
    return (
      <div className={classNamespace('views')}>
        {this.visiableView()}
      </div>
    );
  }
}
