import React, { cloneElement } from 'react';

const extensions = [];
const reducers = {};
const initState = [];

import namespace from './namespace';
import Components from './components';

class ExtensionContext extends React.Component {
  static Components = Components;
  static namespace = namespace;
  static register = function register (reducer) {
    return function (name, component) {
      const exist = extensions.some(ext => ext.name === name);

      if (exist) {
        throw 'extension was already existed';
      }

      Object.keys(reducer).forEach(cst => {
        const key = `EXTENSION_${name.toUpperCase()}_${cst}`;

        reducers[key] = reducer[cst];
      });

      extensions.push({
        name,
        component
      });
    }
  }

  static childContextTypes = {
    extension: React.PropTypes.object
  };

  getChildContext () {
    return {
      extension: {
        reducer: (state = initState, action) => {
          let reducer = reducers[action.type];

          return reducer ? reducer(state, action) : state;
        },

        components: extensions
      }
    };
  }

  render () {

    return (
      this.props.children
    );
  };
}

export default ExtensionContext;