import React, { createElement, cloneElement } from 'react';
import classnames from 'classnames';

import namespace from '../namespace';

import Listview from './listview';
import Item from './item';
import Brief from './brief';
import Button from './button';

import Select from './select';
import Text from './text';

const classNamespace = namespace('app__subject', true);

export default class Subject extends React.Component {
  static Item = Item;
  static Listview = Listview;

  static Select = Select;
  static Text = Text;
  static Brief = Brief;
  static Button = Button;

  titleRender () {
    const { title } = this.props;

    if (title) {
      return (
        <div className={classNamespace('title')}>{title}</div>
      );
    }
  }

  render () {
    const { className, required, title } = this.props;

    const classes = classnames({
      [classNamespace()]: true,
      [className]: !!className
    });

    return (
      <div className={classes}>
        {this.titleRender()}
        {this.props.children}
      </div>
    );
  }
}