import React, { createElement, cloneElement } from 'react';
import classnames from 'classnames';

import namespace from '../../namespace';
import Header from './header';
import Body from './body';

const classNamespace = namespace('app__subject', true);

export default class Item extends React.Component {
  static Header = Header;
  static Body = Body;

  render () {
    const { className, type, vertical } = this.props;

    const classes = classnames({
      [classNamespace('item')]: true,
      [classNamespace('vertical-item')]: !!vertical,
      [classNamespace(`${type}-item`)]: !!type,
      [className]: !!className
    });

    return (
      <div className={classes}>
        {this.props.children}
      </div>
    );
  }
}